package betterwithmods.common.registry.blockmeta.recipe;

import net.minecraft.block.Block;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraftforge.oredict.OreDictionary;

public class BlockMeta {
    private final Block block;
    private final int meta;

    public BlockMeta(Block block, int meta) {
        this.block = block;
        this.meta = meta;
    }

    public BlockMeta(ItemStack stack) {
        Block block = null;
        if (stack.func_77973_b() instanceof ItemBlock)
            block = ((ItemBlock) stack.func_77973_b()).func_179223_d();
        this.block = block;
        this.meta = stack.func_77960_j();
    }

    @Override
    public boolean equals(Object o) {
        if (o instanceof ItemStack) {
            ItemStack stack = (ItemStack) o;
            Block block = null;
            if (stack.func_77973_b() instanceof ItemBlock)
                block = ((ItemBlock) stack.func_77973_b()).func_179223_d();
            int meta = stack.func_77960_j();
            return equals(block, meta);
        }
        if (o instanceof BlockMeta) {
            return equals(((BlockMeta) o).block, ((BlockMeta) o).meta);
        }
        return false;
    }

    public boolean equals(Block block, int meta) {
        return this.block == block && (this.meta == meta || meta == OreDictionary.WILDCARD_VALUE || this.meta == OreDictionary.WILDCARD_VALUE);
    }


    public ItemStack getStack() {
        if (block == null)
            return ItemStack.field_190927_a;
        return new ItemStack(block, 1, meta);
    }

}
