package betterwithmods.module.tweaks;

import betterwithmods.common.BWMItems;
import betterwithmods.module.Feature;
import betterwithmods.util.InvUtils;
import net.minecraft.entity.passive.EntityChicken;
import net.minecraft.entity.projectile.EntityEgg;
import net.minecraft.entity.projectile.EntityThrowable;
import net.minecraft.init.Items;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.DamageSource;
import net.minecraft.util.EnumParticleTypes;
import net.minecraft.util.math.RayTraceResult;
import net.minecraftforge.event.entity.ThrowableImpactEvent;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;

import java.util.Random;

/**
 * Created by primetoxinz on 5/3/17.
 */
public class EggDrops extends Feature {

    @SubscribeEvent
    public void getRawEgg(ThrowableImpactEvent event) {
        if (event.getEntityThrowable() instanceof EntityEgg) {
            event.setCanceled(true);
            RayTraceResult result = event.getRayTraceResult();
            EntityThrowable egg = event.getEntityThrowable();
            Random rand = egg.func_130014_f_().field_73012_v;
            if (result.field_72308_g != null) {
                result.field_72308_g.func_70097_a(DamageSource.func_76356_a(egg, egg.func_85052_h()), 0.0F);
            }

            if (!egg.func_130014_f_().field_72995_K) {
                if (rand.nextInt(8) == 0) {
                    int i = 1;

                    if (rand.nextInt(32) == 0) {
                        i = 4;
                    }

                    for (int j = 0; j < i; ++j) {
                        EntityChicken entitychicken = new EntityChicken(egg.func_130014_f_());
                        entitychicken.func_70873_a(-24000);
                        entitychicken.func_70012_b(egg.field_70165_t, egg.field_70163_u, egg.field_70161_v, egg.field_70177_z, 0.0F);
                        egg.func_130014_f_().func_72838_d(entitychicken);
                    }
                } else {
                    InvUtils.ejectStack(egg.func_130014_f_(), egg.field_70165_t, egg.field_70163_u, egg.field_70161_v, new ItemStack(BWMItems.RAW_EGG));
                }
            }

            for (int k = 0; k < 8; ++k) {
                egg.func_130014_f_().func_175688_a(EnumParticleTypes.ITEM_CRACK, egg.field_70165_t, egg.field_70163_u, egg.field_70161_v, ((double) rand.nextFloat() - 0.5D) * 0.08D, ((double) rand.nextFloat() - 0.5D) * 0.08D, ((double) rand.nextFloat() - 0.5D) * 0.08D, Item.func_150891_b(Items.field_151110_aK));
            }

            if (!egg.func_130014_f_().field_72995_K) {
                egg.func_70106_y();
            }
        }
    }

    @Override
    public boolean requiresMinecraftRestartToEnable() {
        return true;
    }

    @Override
    public boolean hasSubscriptions() {
        return true;
    }

    @Override
    public String getFeatureDescription() {
        return "When an Egg does not spawn a Baby Chicken it drops a Raw Egg, which can be used for multiple different foods.";
    }
}
